package com.sun.corba.se.impl.io;

import java.util.Stack;
import com.sun.org.omg.CORBA.ValueDefPackage.FullValueDescription;
import org.omg.CORBA.CompletionStatus;
import javax.rmi.CORBA.Util;
import com.sun.org.omg.CORBA.Repository;
import javax.rmi.CORBA.ValueHandler;
import com.sun.corba.se.impl.logging.OMGSystemException;
import org.omg.CORBA.ORB;
import java.util.Hashtable;
import com.sun.org.omg.SendingContext._CodeBaseImplBase;

public class FVDCodeBaseImpl extends _CodeBaseImplBase
{
    private static Hashtable fvds;
    private transient ORB orb;
    private transient OMGSystemException wrapper;
    private transient ValueHandlerImpl vhandler;
    
    public FVDCodeBaseImpl() {
        this.orb = null;
        this.wrapper = OMGSystemException.get("rpc.encoding");
        this.vhandler = null;
    }
    
    void setValueHandler(ValueHandler valueHandler) {
        this.vhandler = (ValueHandlerImpl)valueHandler;
    }
    
    public Repository get_ir() {
        return null;
    }
    
    public String implementation(String s) {
        try {
            if (this.vhandler == null) {
                this.vhandler = ValueHandlerImpl.getInstance(false);
            }
            String codebase = Util.getCodebase(this.vhandler.getClassFromType(s));
            if (codebase == null) {
                return "";
            }
            return codebase;
        }
        catch (ClassNotFoundException ex) {
            throw this.wrapper.missingLocalValueImpl(CompletionStatus.COMPLETED_MAYBE, ex);
        }
    }
    
    public String[] implementations(String[] array) {
        String[] array2 = new String[array.length];
        for (int i = 0; i < array.length; ++i) {
            array2[i] = this.implementation(array[i]);
        }
        return array2;
    }
    
    public FullValueDescription meta(String s) {
        try {
            FullValueDescription value = (FullValueDescription)FVDCodeBaseImpl.fvds.get(s);
            if (value == null) {
                if (this.vhandler == null) {
                    this.vhandler = ValueHandlerImpl.getInstance(false);
                }
                try {
                    value = ValueUtility.translate(this._orb(), ObjectStreamClass.lookup(this.vhandler.getAnyClassFromType(s)), this.vhandler);
                }
                catch (Throwable t) {
                    if (this.orb == null) {
                        this.orb = ORB.init();
                    }
                    value = ValueUtility.translate(this.orb, ObjectStreamClass.lookup(this.vhandler.getAnyClassFromType(s)), this.vhandler);
                }
                if (value != null) {
                    FVDCodeBaseImpl.fvds.put(s, value);
                }
                else {
                    throw this.wrapper.missingLocalValueImpl(CompletionStatus.COMPLETED_MAYBE);
                }
            }
            return value;
        }
        catch (Throwable t2) {
            throw this.wrapper.incompatibleValueImpl(CompletionStatus.COMPLETED_MAYBE, t2);
        }
    }
    
    public FullValueDescription[] metas(String[] array) {
        FullValueDescription[] array2 = new FullValueDescription[array.length];
        for (int i = 0; i < array.length; ++i) {
            array2[i] = this.meta(array[i]);
        }
        return array2;
    }
    
    public String[] bases(String s) {
        try {
            if (this.vhandler == null) {
                this.vhandler = ValueHandlerImpl.getInstance(false);
            }
            Stack<String> stack = new Stack();
            for (Class clazz = ObjectStreamClass.lookup(this.vhandler.getClassFromType(s)).forClass().getSuperclass(); !clazz.equals(Object.class); clazz = clazz.getSuperclass()) {
                stack.push(this.vhandler.createForAnyType(clazz));
            }
            String[] array = new String[stack.size()];
            for (int i = array.length - 1; i >= 0; ++i) {
                array[i] = (String)stack.pop();
            }
            return array;
        }
        catch (Throwable t) {
            throw this.wrapper.missingLocalValueImpl(CompletionStatus.COMPLETED_MAYBE, t);
        }
    }
    
    static {
        FVDCodeBaseImpl.fvds = new Hashtable();
    }
}
